#pragma once
#include "Global.h"

#define DEF_BTN_MARGIN_RIGHT_POS_X		(4)
#define MARGIN_BOX						(1)
#define MARGIN_MAXIMIZED				(1)
#define DEF_SYSTEM_BTN_GAP				(1)

// CSkinDialog dialog
class CSkinDialog : public CDialog
{
public:
	CSkinDialog(UINT nResourceID, CWnd* pParent = NULL);   // standard constructor

	enum	{	CLICKED_BOX_NONE = 0,
				CLICKED_BOX_MINIMIZE,
				CLICKED_BOX_MAXIMIZE,
				CLICKED_BOX_RESTORE,
				CLICKED_BOX_EXIT,
				CLICKED_BOX_CUSTOM
			};

// Attributes
public:
	HRGN		m_hRgnWnd;

	CBrush		m_CtlColorBrush;

	int			m_nClickedBox;		//  Ŭ ڽ 

	BOOL		m_bTracking;		//  콺 ڽ ִ ƴ  ÷
	BOOL        m_bShowTitle;       // ŸƲ  

	BOOL		m_bDraging;			// 찡 콺 巡׷ ̵  ƴ  ÷
	BOOL		m_bSizeCursor;		// Ŀ   ƴ  ÷

	BOOL		m_bActive;

	COLORREF	m_cfText;			// ؽƮ 
	COLORREF	m_cfMask;			// ũ 
	COLORREF    m_cfBK;				//̾α ⺻ 

	CFont		m_fntBold;

	// Ʈ 
	SIZE		m_sizeCapL;			//  ĸ 
	SIZE		m_sizeCapM;			//  ĸ ߾
	SIZE		m_sizeCapR;			//  ĸ 
	SIZE		m_sizeFrmL;			//   
	SIZE		m_sizeFrmLB;		//   ʾƷ
	SIZE		m_sizeFrmB;			//   Ʒ
	SIZE		m_sizeFrmR;			//   
	SIZE		m_sizeFrmRB;		//   ʾƷ
	SIZE		m_sizeBox;			//  ִ/ּ ڽ 

	SIZE        m_sizeCustomBox;    // ߰ ư 
	CRect       m_rcCustomBox;      // ߰ ư ġ
	BOOL        m_bShowCustomBtn;   // ߰ ư show

	// Ʈ ڵ
	HBITMAP		m_hBmpCapL;			//  ĸ 
	HBITMAP		m_hBmpCapM;			//  ĸ ߾
	HBITMAP		m_hBmpCapR;			//  ĸ 
	HBITMAP		m_hBmpFrmL;			//   
	HBITMAP		m_hBmpFrmLB;		//   ʾƷ
	HBITMAP		m_hBmpFrmB;			//   Ʒ
	HBITMAP		m_hBmpFrmR;			//   
	HBITMAP		m_hBmpFrmRB;		//    Ʒ

	HBITMAP		m_hBmpMinimize;		//  ּ ڽ
	HBITMAP		m_hBmpMaximize;		//  ִ ڽ
	HBITMAP		m_hBmpRestore;		//   ڽ
	HBITMAP		m_hBmpExit;			//   ڽ

	HBITMAP		m_hBmpCustom;		// ּҹڽ տ  ߰ ڽ 

	int m_nMinWidth, m_nMinHeight;	// ּҳ 

	BOOL        m_bExitBtnActHide;	//ݱư Ŭ ׳ hideų 
	BOOL        m_bMoveTransParent; // ̵ ϰ ׸ 

	BOOL        m_bCloseEvent;      //close̺Ʈ  ó 

	//  ڵ
	HICON		m_hIcon;
	CGlobal		Global;

// Operations
public:
	virtual void		DrawFrame();

	BOOL		SetLeftTopBitmap(CString strPath);
	BOOL		SetCenterTopBitmap(CString strPath);
	BOOL		SetRightTopBitmap(CString strPath);
	BOOL		SetLeftBorderBitmap(CString strPath);
	BOOL		SetRightBorderBitmap(CString strPath);
	BOOL		SetLeftBottomBitmap(CString strPath);
	BOOL		SetCenterBottomBitmap(CString strPath);
	BOOL		SetRightBottomBitmap(CString strPath);
	BOOL		SetDlgIcon(CString strPath);

	BOOL		SetMaxBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath);
	BOOL		SetRestoreBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath);
	BOOL		SetMinBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath);
	BOOL		SetExitBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath);
	BOOL		SetCustomBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath);

	void		SetWindowMinSize(int nWidth, int nHeight);
	void		SetExitBtnActHide(BOOL bHide)									{ m_bExitBtnActHide = bHide; }
	void		SetMoveTransParent(BOOL bTransparent)							{ m_bMoveTransParent = bTransparent; }
	void		SetShowTitle(BOOL bShow)										{ m_bShowTitle = bShow; }
	void		SetCloseEvent(BOOL bEvent)										{ m_bCloseEvent = bEvent; }

	void		SetCtlColor(COLORREF crCtlColor);
	void		SetDlgBKColor(COLORREF bkcolor);
	CRect		GetCustomBtnRect(void);
	void		ShowCustomBtn(bool bShow);
	void		SetDlgIcon(UINT nResourceID);

	DECLARE_MESSAGE_MAP()
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS* lpncsp);
	afx_msg void OnPaint();
	afx_msg void OnNcPaint();
	afx_msg BOOL OnNcActivate(BOOL bActive);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);	
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
};
